function stoch_out = run_clustermap(searchPath, paramsFile, jobsFile, ...
				    lagNumber, jobNumber, groupLength)
%
% Traditional STAMP wrapper function, adpated to STAMPAS.
% It is the actual executable processed on Condor. Reading
% from param files and jobfiles, it executes both pre-proc
% and analysis, and writes the results in the appropriate
% search repertory.
%
% Adapted to STAMPAS by: Samuel Franco (franco@lal.in2p3.fr)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% For injections, lagNumber is a "coded" number: 
% wvf_idx + 100*injection_idx
% One assumes here that no more than 99 different waveforms 
% are used.

tic;

% output file prefix
stoch_out.start=true;

% Display hostname, useful
% system('hostname');

[~, username] = system('echo $USER');
username = strtrim(username);
dagIdx = regexp(searchPath, '/');
dagDir = searchPath(dagIdx(end)+1:end);
localPath = fullfile('/local',username, dagDir);
system(['mkdir -p ', localPath]);

% Load STAMP default parameters
params = stampDefaults;

% Load search parameters (generated by setup_config.m)
load([searchPath '/tmp/clustParam.mat']);

% Parameters of the job
 
% window index of the first window to analyze in this job. The
% window index refers to a row in the joblist file.
first_window=strassign(jobNumber);
jobNumber=strassign(jobNumber);

% overlap in second between 2 overlapping windows
overlap=strassign(overlap);

% number of windows analyzed in a job
windows_group_nb=strassign(groupLength);

% do injection or not
doInj=strassign(doInj);

% save diagnostic plots
doDgPlots=strassign(doDgPlots);
params.savePlots=false;

% save mat files
params.saveMat=false;

% Zebragard algorithm
doZebra=strassign(doZebra);

% Seedless algorithm
doSeedless=strassign(doSeedless);

% Seedless algorithm all-sky
doSeedlessAllsky=strassign(doSeedlessAllsky);

% Seedless algorithm (Lonetrack)
doLonetrack=strassign(doLonetrack);

% Parallel matlab toolbox use
doParallel=strassign(doParallel);

% GPU use
doGPU=strassign(doGPU);

% segment duration
segDur=strassign(segDur);

% fixedSkyPosition
fixedSkyPosition = strassign(fixedSkyPosition);
params.fixedSkyPosition = fixedSkyPosition;
fixedRa = strassign(fixedRa);
fixedDec = strassign(fixedDec);
params.ra = fixedRa;
params.dec = fixedDec;

if ~doSeedless
  % create loop over search directions
  if doZebra==1
    params.skypatch = false;
    params.fastring = false;
  else
    params.skypatch = true;
    params.fastring = true;
  end

  % sky resolution parameters
  if strcmp(pair,'H1L1')
    params.dtheta=0.7;
  else
    params.dtheta=0.3;
  end
  params.thetamax = 180;

  % save all clusters
  params.doAllClusters=true;

  % for overlapping ft-maps and to unify the results format
  params.stochPlus = true; 

end

% alternative sigma to compute the SNR
params.alternative_sigma = altSigma;

% min and max frequency of the search
params.fmin = strassign(fmin);
params.fmax = strassign(fmax);

% apply notches
params.doStampFreqMask = str2num(doStampFreqMask);
if params.doStampFreqMask
   params.StampFreqsToRemove = textread([searchPath '/tmp/frequencies.txt'],'%d',-1,'commentstyle','matlab');

   params.StampFreqsToRemove = params.StampFreqsToRemove(params.StampFreqsToRemove>=params.fmin);
   params.StampFreqsToRemove = params.StampFreqsToRemove(params.StampFreqsToRemove<=params.fmax);

   if segDur < 1
      ff = params.fmin:(1/segDur):params.fmax;
      params.StampFreqsToRemove = intersect(ff,params.StampFreqsToRemove);
   end
else % initialize to empty array
   params.StampFreqsToRemove = [];
end

if segDur < 1
  params.glitch.doCut = false;
  params.glitch.numBands = 1;
  params.glitch.doCoincidentCut = false;
else
  % apply a glitch cut
  params.glitch.doCut = true;
  params.glitch.doCoincidentCut = false;
  if doSeedless
    params.glitch.Xi_frac = 0.15;
    params.glitch.numBands = 6;
  else
    params.glitch.Xi_frac = 0.027;
    params.glitch.numBands = 3;
  end
end

% Jobfiles (bknd_jobfile.txt for TS, joblist_injections.txt for
% injections and joblistTrue.txt for ZL)
params.anteproc.jobfile=jobsFile;

if doSeedless
  % Set seedless parameters based on parameters in seedless params
  % file
  params = getSeedlessParams(params,seedlessParams,doLonetrack)

  % Set GPU or Parallel CPU/GPU usage
  params.doGPU = doGPU;
  params.doParallel = doParallel;

  % Initialization of the matlabpool when using parallel (and GPU)
  params=initParallel(params);
else 
  % perform a clustering search, use default burstegard parameters
  params = burstegardDefaults(params);

  % Uses zebragard to speed-up the search
  if doZebra==1
    params=zebragardDefaults(params);
  end
end

if doInj
  % only 1 type of injection per job
  num=strassign(lagNumber);
  waveformIndex=mod(num,100);

  injectionIndex=(num-waveformIndex)/100;

  lagIndex=0;
  % load a generic file for each waveform that contains a structure
  % 'parameters' generated by setup_config.m. This structure stores
  % the generic waveform parameters. We will update the structure
  % and save it in a file before the loop on windows.

  load([searchPath '/tmp/parameters_' num2str(waveformIndex) '.mat']);
  if waveformIndex==0
    alphas_nb=1;
  else
    alphas_nb=size(parameters.alphas,2);
  end

  % No matfiles available for injections. Injections are done in
  % time domain.
  params.matavailable=false;

  % Do something special with the jobfile
  % Because STAMP does not seem to like overlapping segments when generating
  % data "on the flow", we create a minimal jobfile with only the job we are interested in
  % We save the full injection joblist
  params.jobsFileTotal = [searchPath '/tmp/joblist_injections.txt'];


else

  % background or zero lag
  % only 1 lag value per job
  lagIndex=strassign(lagNumber);
  alphas_nb=1;

  % Describes where to find pre-processed .mat files.
  params.anteproc.loadFiles = true;
  itf1Prefix=[pair(1) '-' pair(1:2) '_' matfilesName];
  itf2Prefix=[pair(3) '-' pair(3:4) '_' matfilesName];
  params.anteproc.inmats1 = [matfilesPath '/' itf1Prefix];
  params.anteproc.inmats2 = [matfilesPath '/' itf2Prefix];
  
  % Cachefiles option (cachefile tells code where
  % the pre-processed files are).  This option is
  % Typically used when pre-processed files are
  % stored on the nodes
  useCachefiles = exist([searchPath '/anteproc_cache.mat'])==2;
  if useCachefiles
    params.anteproc.useCache = true;
    params.anteproc.cacheFile = [searchPath '/anteproc_cache.mat'];
  end
  
  % Time-shift amount (if doing a "time-based" time-shift).
  params.anteproc.timeShift1 = 0;
  params.anteproc.timeShift2 = 0;
  
  % Do a jobfile time-shift?
  params.anteproc.jobFileTimeShift = true;

  % No stitching of the data. No check to be done
  params.anteproc.bkndstudy = false;
end

save_dir=num2str(lagIndex);
% Loads the joblist. A joblist is the list of windows that are
% analyzed for a search. So a job here is actually a window.
jobs=load(jobsFile);

system(['mkdir -p ' searchPath '/LonetrackPProc/lonetrack_' save_dir]);
system(['mkdir -p ' localPath '/LonetrackPProc/lonetrack_' save_dir]);

% Loop over each window in a group (science segment or injection group
% of three windows).
for subJob=1:windows_group_nb
  windowIndex=first_window+subJob-1;

  fprintf('\nsubJob: %d window index: %d\n',subJob, windowIndex);

  % anteproc pre-processing parameters
  % Define the job/window for each detector?
  params.anteproc.jobNum1 = windowIndex;
  params.anteproc.jobNum2 = windowIndex;

  % start and end time to process
  t_start=jobs(windowIndex,2);
  t_end=jobs(windowIndex,3);

  % call clustermap
  display(['t_start: ' num2str(t_start) ' t_end: ' num2str(t_end)]);
  params.startGPS = t_start; params.endGPS = t_end;

  lonetrackPath = [searchPath '/Lonetrack/'];
  bkndoutputDir = [lonetrackPath '/bknd'];
  stage1 = load([bkndoutputDir '/stage1.mat']);

  pass1 = stage1.pass1; pass2 = stage1.pass2;
  nslides = stage1.nslides; nsh = stage1.nsh;
  filenames = stage1.filenames;

  pass = zeros(size(pass1));
  pass(find(pass1)) = 1; 
  pass(find(pass2)) = 1;

  if stage1.lonetrackNSlides > 0
    i1 = find(pass1); i2 = find(pass2);

    t1 = [];
    for jj = 1:length(i1)
      lonetrackFile = filenames{i1(jj)};
      lonetrackFileSplit = regexp(strrep(lonetrackFile,'.mat',''),'_','split');
      thistime = str2num(lonetrackFileSplit{end});
      t1 = [t1 thistime];
    end

    t2 = [];
    for jj = 1:length(i2)
      lonetrackFile = filenames{i2(jj)};
      lonetrackFileSplit = regexp(strrep(lonetrackFile,'.mat',''),'_','split');
      thistime = str2num(lonetrackFileSplit{end});
      t2 = [t2 thistime];
    end
    [junk,indexes1] = sort(abs(t_start-t1),'ascend');
    indexes1 = indexes1(1:stage1.lonetrackNSlides);

    [junk,indexes2] = sort(abs(t_start-t2),'ascend');
    indexes2 = indexes2(1:stage1.lonetrackNSlides);

    pass1 = zeros(size(pass1));
    pass2 = zeros(size(pass2));
    pass1(i1(indexes1)) = 1; pass2(i2(indexes2)) = 1;
  end

  % call halftrack_bknd for clusters passing stage 1
  snrmax1=[];  snrmax2=[];
  snrfrac1=[];  snrfrac2=[];
  timedelay1=[];  timedelay2=[];
  gpstime1=[]; gpstime2=[];
  mapindex1=[]; mapindex2=[];
  lagindex1=[]; lagindex2=[];

  for jj=1:nslides
    fprintf('Analyzed slide %d/%d\n',jj,nslides);
    lonetrackFile = filenames{jj};
    lonetrackFileSplit = regexp(strrep(lonetrackFile,'.mat',''),'_','split');
    thistime = str2num(lonetrackFileSplit{end});

    ntrig = nsh;    
    % exclude zero
    if thistime == t_start
       pass1(jj) = 0; pass2(jj) = 0;
    end
 
    % look for LHO cluster in LLO data
    if pass1(jj)
      [tmp1,tmp2,tmp3,tmp4] = halftrack_bknd(params, lonetrackFile, 1);
      snrmax1=[snrmax1 tmp1];
      snrfrac1=[snrfrac1 tmp2];
      timedelay1=[timedelay1 tmp3];
      gpstime1=[gpstime1 tmp4]; 
      mapindex1=[mapindex1 jj*ones(size(tmp4))];
      lagindex1=[lagindex1 0:length(tmp1)-1];
    else
      snrmax1=[snrmax1 NaN*ones(1,ntrig)];
      snrfrac1=[snrfrac1 NaN*ones(1,ntrig)];
      timedelay1=[timedelay1 NaN*ones(1,ntrig)];
      gpstime1=[gpstime1 NaN*ones(1,ntrig)];
      mapindex1=[mapindex1 NaN*ones(1,ntrig)];
      lagindex1=[lagindex1 NaN*ones(1,ntrig)];
    end
    % look for LLO cluster in LHO data
    if pass2(jj)
      [tmp1,tmp2,tmp3,tmp4] = halftrack_bknd(params, lonetrackFile, 2);
      snrmax2=[snrmax2 tmp1];
      snrfrac2=[snrfrac2 tmp2];
      timedelay2=[timedelay2 tmp3];
      gpstime2=[gpstime2 tmp4];
      mapindex2=[mapindex2 jj*ones(size(tmp4))];
      lagindex2=[lagindex2 0:length(tmp1)-1];
    else
      snrmax2=[snrmax2 NaN*ones(1,ntrig)];
      snrfrac2=[snrfrac2 NaN*ones(1,ntrig)];
      timedelay2=[timedelay2 NaN*ones(1,ntrig)];
      gpstime2=[gpstime2 NaN*ones(1,ntrig)];
      mapindex2=[mapindex2 NaN*ones(1,ntrig)];
      lagindex2=[lagindex2 NaN*ones(1,ntrig)];
    end
  end

  % halftrack results
  [snrmax,idx] = max([snrmax1 ; snrmax2]);
  timedelay = zeros(size(snrmax));
  timedelay(idx == 1) = timedelay1(idx == 1);
  timedelay(idx == 2) = timedelay2(idx == 2);
  gpstime = zeros(size(snrmax));
  gpstime(idx == 1) = gpstime1(idx == 1);
  gpstime(idx == 2) = gpstime2(idx == 2);
  snrfrac = zeros(size(snrmax));
  snrfrac(idx == 1) = snrfrac1(idx == 1);
  snrfrac(idx == 2) = snrfrac2(idx == 2);  
  mapindex = zeros(size(snrmax));
  mapindex(idx == 1) = mapindex1(idx == 1);
  mapindex(idx == 2) = mapindex2(idx == 2);
  lagindex = zeros(size(snrmax));
  lagindex(idx == 1) = lagindex1(idx == 1);
  lagindex(idx == 2) = lagindex2(idx == 2);

  idy = find(~isnan(snrmax));
  snrmax = snrmax(idy); timedelay = timedelay(idy);
  gpstime = gpstime(idy); snrfrac = snrfrac(idy);
  mapindex = mapindex(idy); lagindex = lagindex(idy);
  idx = idx(idy);

  localFile = [localPath '/LonetrackPProc/lonetrack_' save_dir '/lonetrack_' num2str(t_start,20) '.mat'];
  searchFile = [searchPath '/LonetrackPProc/lonetrack_' save_dir '/lonetrack_' num2str(t_start,20) '.mat']
  save(localFile,'snrmax','snrfrac','timedelay','gpstime','mapindex','lagindex','idx','pass','pass1','pass2');
  system(['mv ' localFile ' ' searchFile]);
  data_out = load(searchFile);
end

toc;


